<!DOCTYPE html>
<html lang="en">

<head>
   <meta charset="UTF-8">
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   <meta http-equiv="X-UA-Compatible" content="ie=edge">
   <title>Document</title>
</head>

<body>
   <script>
      class Forma {
         dibujar() {
            console.log('dibuja forma...');
         }
         borrar() {
            console.log('borra forma...');
         }
      }

      class Circulo extends Forma {
         dibujar() {
            console.log('Calcula diametro');
            console.log('bibuja circulo');
         }
         borrar() {
            console.log('borra circulo...');
         }
         hacerOtraCosa() {
            console.log('hace otra cosa.....');
         }
      }

      class Cuadrado extends Forma {
         dibujar() {
            console.log('dibuja lado a');
            console.log('dibuja lado b');
            console.log('dibuja lado c');
            console.log('dibuja lado d');
         }
         borrar() {
            console.log('borra cuadrado...');
         }
      }

      class Pantalla {
         mostrarFormas(forma) {
            forma.dibujar();
         }

         limpiarPantalla(forma) {
            forma.borrar();
         }
      }

      let circulo1 = new Circulo();
      let circulo2 = new Circulo();
      let cuadrado1 = new Cuadrado();
      let myPantalla = new Pantalla();

      myPantalla.mostrarFormas(circulo1);
      myPantalla.limpiarPantalla(circulo1);

      myPantalla.mostrarFormas(circulo2);
      myPantalla.limpiarPantalla(circulo2);

      myPantalla.mostrarFormas(cuadrado1);
      myPantalla.limpiarPantalla(cuadrado1);
   </script>
</body>

</html>